#!/usr/bin/python
# coding=utf-8
import sys
import logging
import codecs
from xml.dom import minidom

class XmlRepresentation(object):
    _doc = None

    def __init__(self, filename):
        self._doc = minidom.parse(filename)

    """
     Task 1, part A: Complete this method. You are likely to consult the Python
     xml.dom documentation when working on this task.

     You can suppose that the input document is always valid, i.e. its
     structure fulfills the criteria specified in the comments inside the
     document company.xml.

     Returns the average salary at given position for each division in the
     company.

     position-- the position its average salary has to be calculated.

     returns: Element "avgsalaries" containing for each division 
     elements "avgsalary" with the average salary at this division 
     at the given position. The average salary is stored in its text content 
     and the division id as its attribute "did".
      
     I.e. the demo output should look like:
      
     Average salaries at position tester:
     <?xml version="1.0" encoding="UTF-8"?>
     <avgsalaries><avgsalary did="production_zlin" position="tester">39000.0</avgsalary>
     <avgsalary did="development_brno" position="tester">26422.75</avgsalary></avgsalaries>

    """
    def average_salaries_at_position(self, position):
        salaries = self._doc.createElement("avgsalaries")
        return salaries

    """
     Task 1, part B: Complete this method. The method adds a new note to an
     existing person identified by its person ID (pid) and returns 
     this person element. If such a person does
     not exist, the method does nothing and returns null.

     pid -- pid of the person to add the note to this person. pid must not be
        null nor empty (the method does not check it)
     note -- the note to be added to the person with the given pid

     returns: the Element person with the given pid and new note added 
     or null if such person Element does not exist.
     I.e. the demo should produce the following output:
      
     Person with pid=1 is now:
     <?xml version="1.0" encoding="UTF-8"?>
     <person pid="1"> 	
     <!-- name is required, non-empty string -->	 
     <name>Pavel</name>	 
     <!-- surname is required, non-empty string -->
     <surname>Novák</surname> 
     <!-- note optional element, repeatable, contains any string -->  
     <note>Poznámka</note>   
     <note>New note to person 1</note></person>

    """
    def add_note(self, pid, note):
        pass

    def serialize_to_xml(self, filename):
        outputfile = codecs.open(filename, "wb", "utf-8")
        self._doc.writexml(outputfile, encoding="utf-8")

def task1():
    if len(sys.argv) != 3:
        logging.error("You have to enter input and output file")
        sys.exit(1)

    inputfilename = sys.argv[1]
    outputfilename = sys.argv[2]

    xml = XmlRepresentation(inputfilename)
    print "Average salaries at position tester:"
    print xml.average_salaries_at_position("tester").toxml()

    print "Person with pid=1 is now:"
    result = xml.add_note("1", "New note to person 1")
    if result is not None:
        print result.toxml()
    xml.serialize_to_xml(outputfilename)

if __name__ == "__main__":
    task1()
